Index: /trunk/BNC/bncpostprocess.cpp
===================================================================
--- /trunk/BNC/bncpostprocess.cpp	(revision 3716)
+++ /trunk/BNC/bncpostprocess.cpp	(revision 3717)
@@ -45,5 +45,5 @@
 #include "pppopt.h"
 #include "bncpppclient.h"
-#include "rnxobsfile.h"
+#include "rinex/rnxobsfile.h"
 #include "rnxnavfile.h"
 #include "corrfile.h"
@@ -136,5 +136,5 @@
   // -------------------------
   int   nEpo = 0;
-  const t_rnxObsFile::t_epo* epo = 0;
+  const t_rnxObsFile::t_rnxEpo* epo = 0;
   while ( (epo = _rnxObsFile->nextEpoch()) != 0 ) {
     ++nEpo;
@@ -144,11 +144,11 @@
     }
 
-    for (int iObs = 0; iObs < epo->satObs.size(); iObs++) {
-      const t_rnxObsFile::t_satObs& satObs = epo->satObs[iObs];
+    for (unsigned iObs = 0; iObs < epo->rnxSat.size(); iObs++) {
+      const t_rnxObsFile::t_rnxSat& rnxSat = epo->rnxSat[iObs];
       t_obs obs;
       strncpy(obs.StatID, _rnxObsFile->markerName().toAscii().constData(),
               sizeof(obs.StatID));
-      obs.satSys   = satObs.prn.toAscii().data()[0];
-      obs.satNum   = satObs.prn.mid(1).toInt();
+      obs.satSys   = rnxSat.satSys;
+      obs.satNum   = rnxSat.satNum;
       obs.GPSWeek  = epo->tt.gpsw();
       obs.GPSWeeks = epo->tt.gpssec();
@@ -156,20 +156,20 @@
         QByteArray type = _rnxObsFile->obsType(obs.satSys,iType).toAscii();
         if      (type.indexOf("C1") == 0 && obs.C1  == 0.0) {
-          obs.C1 = satObs[iType];
+          obs.C1 = rnxSat.obs[iType];
         }
         else if (type.indexOf("P1") == 0 && obs.P1  == 0.0) {
-          obs.P1 = satObs[iType];
+          obs.P1 = rnxSat.obs[iType];
         }
         else if (type.indexOf("L1") == 0 && obs.L1C == 0.0) {
-          obs.L1C = satObs[iType];
+          obs.L1C = rnxSat.obs[iType];
         }
         else if (type.indexOf("C2") == 0 && obs.C2  == 0.0) {
-          obs.C2 = satObs[iType];
+          obs.C2 = rnxSat.obs[iType];
         }
         else if (type.indexOf("P2") == 0 && obs.P2  == 0.0) {
-          obs.P2 = satObs[iType];
+          obs.P2 = rnxSat.obs[iType];
         }
         else if (type.indexOf("L2") == 0 && obs.L2C == 0.0) {
-          obs.L2C = satObs[iType];
+          obs.L2C = rnxSat.obs[iType];
         }
       }
Index: /trunk/BNC/rinex/rnxobsfile.h
===================================================================
--- /trunk/BNC/rinex/rnxobsfile.h	(revision 3716)
+++ /trunk/BNC/rinex/rnxobsfile.h	(revision 3717)
@@ -26,6 +26,7 @@
 #define RNXOBSFILE_H
 
+#include <QString>
+
 #include <fstream>
-#include <string>
 #include <vector>
 #include <map>
@@ -58,5 +59,5 @@
   };
 
-  t_rnxObsFile(const std::string& fileName);
+  t_rnxObsFile(const QString& fileName);
   ~t_rnxObsFile();
   
@@ -64,8 +65,8 @@
   double              interval() const {return _header._interval;}
   int                 nTypes(char sys) const {return _header.nTypes(sys);}
-  const std::string&  fileName() const {return _fileName;}
-  const std::string&  obsType(char sys, int index) const {return _header.obsType(sys, index);}
-  const std::string&  antennaName() const {return _header._antennaName;}
-  const std::string&  markerName() const {return _header._markerName;}
+  const QString&      fileName() const {return _fileName;}
+  const QString&      obsType(char sys, int index) const {return _header.obsType(sys, index);}
+  const QString&      antennaName() const {return _header._antennaName;}
+  const QString&      markerName() const {return _header._markerName;}
   const ColumnVector& xyz() const {return _header._xyz;}
   const ColumnVector& antNEU() const {return _header._antNEU;}
@@ -82,5 +83,5 @@
  protected:
   t_rnxObsFile() {};
-  void open(const std::string& fileName);
+  void open(const QString& fileName);
   void close();
 
@@ -91,28 +92,28 @@
     ~t_rnxObsHeader();
 
-    t_irc               read(std::ifstream* stream, int maxLines = 0);
-    int                 nTypes(char sys) const;
-    const std::string&  obsType(char sys, int index) const;
+    t_irc           read(std::ifstream* stream, int maxLines = 0);
+    int             nTypes(char sys) const;
+    const QString&  obsType(char sys, int index) const;
  
-    static const std::string                  _emptyStr;
-    float                                     _version;
-    double                                    _interval;
-    std::string                               _antennaName;
-    std::string                               _markerName;
-    ColumnVector                              _antNEU;
-    ColumnVector                              _antXYZ;
-    ColumnVector                              _antBSG;
-    ColumnVector                              _xyz;
-    std::vector<std::string>                  _obsTypesV2;
-    std::map<char, std::vector<std::string> > _obsTypesV3;
-    int                                       _wlFactorsL1[MAXPRN_GPS+1];
-    int                                       _wlFactorsL2[MAXPRN_GPS+1];
+    static const QString                  _emptyStr;
+    float                                 _version;
+    double                                _interval;
+    QString                               _antennaName;
+    QString                               _markerName;
+    ColumnVector                          _antNEU;
+    ColumnVector                          _antXYZ;
+    ColumnVector                          _antBSG;
+    ColumnVector                          _xyz;
+    std::vector<QString>                  _obsTypesV2;
+    std::map<char, std::vector<QString> > _obsTypesV3;
+    int                                   _wlFactorsL1[MAXPRN_GPS+1];
+    int                                   _wlFactorsL2[MAXPRN_GPS+1];
   };
 
   const t_rnxEpo* nextEpochV2();
   const t_rnxEpo* nextEpochV3();
-  void handleEpochFlag(int flag, const std::string& line);
+  void handleEpochFlag(int flag, const QString& line);
 
-  std::string    _fileName;
+  QString        _fileName;
   t_rnxObsHeader _header;
   std::ifstream* _stream;